#!/usr/bin/python -u
"""
    Pytecache is a GnutellaNet hosts cachter cacher servant.
    Copyright (C) 2000  Tom Goulet

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    I can be reached at tomg@nova.yi.org.
"""
import pytella			# Hopefully all the functions I need.
import select,time,string

# Format of a conns item:
# [<socket object>, ('ipaddress', port), flag, guid]
# The first item is a socket object returned by socket.socket()
# The second is a tuple returned from <socket object>.accept()
# The third is a flag showing the state of a connection.
# The forth is a GUID that the connection is currently concerned with.

MAXCONNS = 256

def showconns(conns):
	print "Current connections:",
	for i in conns:
		print i[1][0],
	print ""
	return()

def mainloop(s, f, conns):
	showconns(conns)
	for i in conns:
		if conn.flag == -1
	conns.remove(flag
        if pytella.ready(s):
		if len(conns) > MAXCONNS:
			print "Maximum connections reached."
			pytella.close(conns[0][0])
			conns.remove(conns[0])
			print "Oldest connection closed."
		try:
			tmpconn, tmpaddr = pytella.accept(s)
			conns.append([tmpconn, tmpaddr, 4])
			print "New connection:", tmpaddr[0]
		except pytella.AcceptError: pass
	for n in range(len(conns)):
		conns = handleconn(conns, n, f)
	time.sleep(1)

def handleconn(conns, n, f):
	#print "conn flag is:", conn[1]
	if conns[n][2] == -1:
		pytella.close(conns[n][0])
                conns.remove(conns[n])
                print "Connection closed:", conns[n][1][0]
		return(conns)
	elif conns[n][2] in [4,5,6,7]:
		if pytella.ready(conns[n][0]):
			try: rheader, rpayload = pytella.recv(conns[n][0])
			except pytella.RecvError, message:
				if message == 'Receive timeout': return(conns)
				else:
					conns[n][1] = -1
					pytella.close(conns[n][0])
					return(conns)
		else: return(conns)
		guid, func, ttl, hops, length = pytella.parseheader(rheader)
		if func == 'ping':
			print "Ping packet received from:", conns[n][1][0]
			conns[n][2] = 256
			conn.append(guid)
			return(conns)
		else:
			print "Irrelevant packet received from:", conns[n][1][0]
			return(conns)
		if conns[n][2] == 7:
			conns[n][2] = -1
			pytella.close(conns[n][0])
			return(conns)
		else: conns[n][1] = conns[n][1] + 1
	elif conns[i][2] == 255:
		print "conn[1] is 255, this shouldn't happen!"
	elif conns[n][2] > 255:
                ttl = 0
                hops = 0
                host = string.strip(f.readline())
                if host == '':
			f.seek(0)
			host = string.strip(f.readline())
		host = string.split(host)
                host = (host[0], int(host[1]))
		try: pytella.sendpong(conns[n][0], conns[n][3], ttl, hops, host)
                except pytella.SendError, message:
                        if message == 'Send timeout':
				print "Timeout raised."
				return(conns)
                        else:
				print "exception pytella.SendError", message
                                conns[n][2] = -1
                                pytella.close(conns[n][0])
                                return(conns)
		if conns[n][2] == 512:
			pytella.close(conns[n][0])
			conns[n][2] = -1
			return(conns)
		conns[n][2] = conns[n][2] + 1
		return(conns)
	else:
		print "I shouldn't get here!"
		print "conns[n] is:", conns[n]
		return(conns)
	print "I REALLY shouldn't get here."
	print "conns[n] is:", conns[n]
	return(conns)

def main():
	f = open('pytella.hosts', 'r')
	print "Hosts file opened."
	s = pytella.listen(('', 6346))
	print "Pytella listening."
	conns = []
	try:
		while 1:
			mainloop(s, f, conns)
	except:
		s.close()
		f.close()
		raise

main()

# EOF
